%----------------------------------------------%
%    Conservative simulation of pub problem    %
%    written by Ivan Futo		       %
%----------------------------------------------%

problem:-
     new(first_door(3),first_door,_,_,1),
     new(second_door(5),second_door,_,_,2),
     new(service,mixer,_,_,3),
     write("process name - termination time"),nl,
     write("-------------------------------"),nl.

first_door(0):-
     new(send(message(no_more_client,1),[mixer]),
	 terminator1,_,_,1).
first_door(N):-
     new(consume(1,N),customer(1,N),_,_,1),
     advance(3),
     N1 is N - 1,
     first_door(N1).

second_door(0):-
     new(send(message(no_more_client,2),[mixer]),
	 terminator2,_,_,2).
second_door(N):-
     new(consume(2,N),customer(2,N),_,_,2),
     advance(5),
     N1 is N - 1,
     second_door(N1).

consume(A,K):-
     send(message(order(K),A),[mixer]),
     wait_for(served,T),
     set_local_time(T),
     advance(15),
     local_time(LT),
     write(consume(A,K)-LT),nl.

service:-
     wait_for(message(Message1,1),T1),
     wait_for(message(Message2,2),T2),
     service(Message1,T1,Message2,T2).
service(no_more_client,T1,no_more_client,T2).
service(no_more_client,T1,order(K),T2):-
     set_local_time(T2),
     service(2,K).
service(order(K),T1,no_more_client,T2):-
     set_local_time(T1),
     service(1,K).
service(order(K1),T1,order(K2),T2):-
     T1 <= T2,
     set_local_time(T1),advance(4),
     send(served,[customer(1,K1)]),
     wait_for(message(Message,1),T3),
     service(Message,T3,order(K2),T2).
service(order(K1),T1,order(K2),T2):-
     T1 > T2,
     set_local_time(T2),advance(4),
     send(served,[customer(2,K2)]),
     wait_for(message(Message,2),T3),
     service(order(K1),T1,Message,T3).
service(A,K):-
     advance(4),
     send(served,[customer(A,K)]),
     wait_for(message(Mess,A),T),
     decision(Mess,A,T).

decision(no_more_client,_,_).
decision(order(K),A,T):-
     set_local_time(T),
     service(A,K).
