#include "interfac.inc"

#define byte unsigned char
#define function
#define then
#define begin {
#define end }


function cons_univ()
begin
char buff[256];
csp_cell c1, c2, list, elem, tail;
char *str;
int i, l, ret;

  if (get_nth_arg(1,&c1) != true)
    then return(wrong_arg_no);
  if (get_nth_arg(2,&c2) != true)
    then return(wrong_arg_no);

  if (get_cell_type(c1) == t_atom)
    then begin
      get_atom_cell(c1,&str);
      l = strlen(str);
      tail = nil_cell;
      while (l > 0)
	begin
	  l--;
	  if ((ret = make_int_cell((int)str[l],&elem)) != true)
	    then return(ret);
	  if ((ret = make_list_cell(elem,tail,&list)) != true)
	    then return(ret);
	  tail = list;
	end
      return(unify_cell(c2,list));
    end
  if (get_cell_type(c2) == t_list)
    then begin
      l = 0;
      list = c2;
      while (get_cell_type(list) == t_list)
	begin
	  get_list_head(list,&elem);
	  if (get_int_cell(elem,&i) != true)
	    then return(non_integer_argument);
	  if (i < 1 || i > 255)
	    then return(illegal_number);
	  buff[l++] = i;
	  get_list_tail(list,&tail);
	  list = tail;
	end
      buff[l] = '\0';
      if ((ret = make_atom_cell(buff,&elem)) != true)
	then return(ret);
      return(unify_cell(c1,elem));
    end

  return(wrong_arg_no);

end

function univ()
begin
csp_cell c1, c2, name, list;
int arity, i, ret;
csp_cell cell_buff[128];

  get_nth_arg(1,&c1);
  get_nth_arg(2,&c2);

  if (get_cell_type(c1) == t_struct)
    then begin
      get_struct_functor(c1,&name,&arity);
      for (i = 0; i < arity; i++)
	get_struct_arg(c1,i+1,&cell_buff[i]);
      list = nil_cell;
      while (arity > 0)
	begin
	  arity--;
	  if ((ret = make_list_cell(cell_buff[arity],list,&list)) != true)
	    then return(ret);
	end
      if ((ret = make_list_cell(name,list,&list)) != true)
	then return(ret);
      return(unify_cell(list,c2));
    end

  if (get_cell_type(c2) == t_list)
    then begin
      get_list_head(c2,&name);
      get_list_tail(c2,&list);
      arity = 0;
      while (get_cell_type(list) == t_list)
	begin
	  get_list_head(list,&cell_buff[arity++]);
	  get_list_tail(list,&list);
	end
      if ((ret = make_struct_cell(name,arity,cell_buff,&list)) != true)
	then return(ret);
      return(unify_cell(c1,list));
    end

  return(wrong_arg_no);

end

static long csp_ptr = nil;

function my_set_value_b()
begin
byte jelzo;
csp_cell cell;
double f;
char * str;
int i;
int my_reset_value();
char *aux;

  *(long *)&cell = csp_ptr;
  make_trail_note(my_reset_value,cell);

  if (get_nth_arg(1,&cell) != true)
    then return(wrong_arg_no);
  jelzo = get_cell_type(cell);
  switch(jelzo) begin
    case t_float   : if ((csp_ptr = csp_alloc(1 + sizeof(double))) == nil)
		       then return(memory_full);
		     *csp_addr(csp_ptr) = t_float;
		     get_float_cell(cell,&f);
		     *(double *)(csp_addr(csp_ptr) + 1) = f;
		     break;
    case t_atom    : get_atom_cell(cell,&str);
		     if ((csp_ptr = csp_alloc(1+ strlen(str) + 1)) == nil)
		       then return(memory_full);
		     *csp_addr(csp_ptr) = t_atom;
		     strcpy(csp_addr(csp_ptr) + 1,str);
		     break;
    case t_fix	   : if ((csp_ptr = csp_alloc(1+ sizeof(int))) == nil)
		       then return(memory_full);
		     *csp_addr(csp_ptr) = t_fix;
		     get_int_cell(cell,&i);
		     aux = csp_addr(csp_ptr) + 1;
		     *(int *)aux = i;
		     break;
    default	   : return(syntax_error);
  end

  return(true);

end

function my_get_value()
begin
csp_cell cell;
double f;
char * str;
int i;

  if (csp_ptr == nil)
    then return(syntax_error);

  switch(*csp_addr(csp_ptr)) begin
    case t_float   : f = *(double *)(csp_addr(csp_ptr) + 1);
		     make_float_cell(f,&cell);
		     break;
    case t_atom    : make_atom_cell(csp_addr(csp_ptr) + 1,&cell);
		     break;
    case t_fix	   : i = *(int *)(csp_addr(csp_ptr) + 1);
		     make_int_cell(i,&cell);
		     break;
  end

  return(put_nth_arg(1,cell));

end

function my_reset_value(cell)

csp_cell cell;

begin

  switch(*csp_addr(csp_ptr)) begin
    case t_float   : csp_rel(csp_ptr,1 + sizeof(double));
		     break;
    case t_atom    : csp_rel(csp_ptr,1 + strlen(1 + csp_addr(csp_ptr)) + 1);
		     break;
    case t_fix	   : csp_rel(csp_ptr,1 + sizeof(int));
		     break;
  end

  csp_ptr = *(long *)&cell;

end


function member()

begin
csp_cell list, elem, head;
int found;
int next_member();

  if (get_nth_arg(2,&list) != true)
    then return(wrong_arg_no);

  if (get_cell_type(list) != t_list)
    then return(false);

  get_nth_arg(1,&elem);

  create_choice();

  found = false;
  while (found == false && get_cell_type(list) == t_list)
    begin
      get_list_head(list,&head);
      found = try_unify_cell(elem,head);
      get_list_tail(list,&list);
    end

  switch (found) begin
    case false :  return(destroy_choice());
    case true  :  return(set_choice(next_member,list));
    default    :  return(found);
  end

end

function next_member(list)

csp_cell list;

begin
csp_cell elem, head;
int found;
int next_member();

  get_nth_arg(1,&elem);

  found = false;
  while (found == false && get_cell_type(list) == t_list)
    begin
      get_list_head(list,&head);
      found = try_unify_cell(elem,head);
      get_list_tail(list,&list);
    end

  switch (found) begin
    case false :  return(destroy_choice());
    case true  :  return(set_choice(next_member,list));
    default    :  return(found);
  end

end

