#define BITF_INDEX 1
#define LONG_INDEX 1

#define T_INDEX long unsigned
#define T_INT   long int

#define huge

/* Interface for user-defined C functions in CS-PROLOG */

#define nil 0L
#define true  1
#define false 0

#define non_atom_argument	     8
#define non_numeric_argument	  9003
#define memory_full		  9006
#define cannot_open_file	  9007
#define cannot_close_file	  9008
#define no_more_disk_space	  9009
#define syntax_error		  9011
#define wrong_arg_no		  9018
#define floating_point_error	  9022
#define non_opened_file 	  9023
#define non_integer_argument	  9025
#define non_implemented 	  9027
#define non_positive_argument	  9029
#define io_error		  9035
#define illegal_number		  9039
#define illegal_list		  9040

#define t_empty  0x00
#define t_float  0x04
#define t_atom	 0x05
#define t_fix	 0x06
#define t_nil	 0x08
#define t_struct 0x09
#define t_list	 0x0d

typedef struct
   {
     unsigned long flag  : 8;
     unsigned long table : 4;
     unsigned long index : 20;
   }
   csp_cell;

extern csp_cell nil_cell;
extern csp_cell empty_cell;

extern int get_nth_arg();
extern int put_nth_arg();

extern int get_cell_type();

extern int get_int_cell();
extern int get_float_cell();
extern int get_atom_cell();

extern int get_list_head();
extern int get_list_tail();
extern int get_struct_functor();
extern int get_struct_arg();
extern int get_file_cell();

extern int make_int_cell();
extern int make_float_cell();
extern int make_atom_cell();

extern int make_list_cell();
extern int make_struct_cell();

extern int unify_cell();
extern int try_unify_cell();

extern int make_trail_note();
extern long csp_alloc();
extern char *csp_addr();
extern int csp_rel();

extern int create_choice();
extern int set_choice();
extern int destroy_choice();

